# gui.py
# basiert auf Demo_mit_StaticText&TextCtrl_ENTER.py

import wx

from raumplanerModell import RaumplanerModell

### ---------------------------------------------------
class Gui(wx.Frame):
    def __init__(
            self, parent, ID, title, pos=(450,50), # neu
            size=wx.DefaultSize, style=wx.DEFAULT_FRAME_STYLE
            ):

        wx.Frame.__init__(self, parent, ID, title, pos, size, style)
        self.__modell = None
        panel = wx.Panel(self, -1)

        sampleList = ['Badewanne', 'Bett', 'Dusche', 'Herd', 'Klosett', 'OvalerTisch',
                      'Schrank', 'Sessel', 'Sofa', 'Stuhl', 'Tisch']
        self.sampleList=sampleList

        ### Label und TextCtrl
        self.label1 = wx.StaticText(panel, -1, u"ausgewählt")
        self.label1.SetPosition((155, 15))
        self.textCtrl1 = wx.TextCtrl(panel, -1,
                                     "keines",
                                     size=(205, -1),
                                     style=wx.TE_PROCESS_ENTER) ## wichtig!!!
        self.textCtrl1.SetPosition((155, 45))
        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnter, self.textCtrl1)
        self.Bind(wx.EVT_TEXT, self.OnText, self.textCtrl1) ## sinnvoll ??

        ### Menu-Abschnitt
        # Prepare the menu bar
        menuBar = wx.MenuBar()

        # erstes Menue
        dateiMenu = wx.Menu()
        dateiMenu.Append(101, "Oeffnen")
        dateiMenu.Append(102, "Speichern")
        dateiMenu.AppendSeparator()
        dateiMenu.Append(103, "Beenden")
        # Add menu to the menu bar
        menuBar.Append(dateiMenu, "Datei")

        # zweites Menue
        neuMenu = wx.Menu()
        neuMenu.Append(201, "Stuhl", "")
        neuMenu.Append(202, "Tisch", "")
        neuMenu.Append(203, "Schrank", "")
        ##neuMenu.AppendSeparator()
        # Add menu to the menu bar
        menuBar.Append(neuMenu, "&Moebel")
        
        self.SetMenuBar(menuBar)

        ### Menu events
        self.Bind(wx.EVT_MENU, self.OnOeffnen, id=101)
        self.Bind(wx.EVT_MENU, self.OnSpeichern, id=102)
        self.Bind(wx.EVT_MENU, self.OnBeenden, id=103) ## Korrektur

        self.Bind(wx.EVT_MENU, self.OnStuhl, id=201)
        self.Bind(wx.EVT_MENU, self.OnTisch, id=202)
        self.Bind(wx.EVT_MENU, self.OnSchrank, id=203)

        ### Button-Abschnitt
        waehleButton = wx.Button(panel, 1001, u"wähle")
        waehleButton.SetPosition((15, 10))
        self.Bind(wx.EVT_BUTTON, self.OnWaehle, waehleButton)
        
        dreheButton = wx.Button(panel, 1002, "drehe")
        dreheButton.SetPosition((15, 50))        
        self.Bind(wx.EVT_BUTTON, self.OnDrehe, dreheButton)
        
        beendenButton = wx.Button(panel, 1003, "Beenden")
        beendenButton.SetPosition((155, 115))
        self.Bind(wx.EVT_BUTTON, self.OnBeenden, beendenButton)
        ### Fensterereignis
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

        ### Ergänzung um "ListBox"    (panel statt self) 
        self.lb = wx.ListBox(panel, 60, (100, 50), (90, 120), sampleList, wx.LB_SINGLE|wx.LB_OWNERDRAW)
        self.lb.SetPosition((15, 90))
        self.Bind(wx.EVT_LISTBOX, self.EvtListBox, self.lb)
        

    def SetzeModell(self,modell):
        self.__modell = modell

    ### Ereignisbehandlung ###
    ### TextCtrl
    def OnTextEnter(self, event):
        ##print('Enter bei Inhalt "'+self.textCtrl1.GetValue()+'"')
        inhalt=self.textCtrl1.GetValue() # neu
        if inhalt=='keines':
            self.__modell.Waehle(-1)
        try:
            self.__modell.Waehle(int(self.textCtrl1.GetValue())-1)  # neu!
        except ValueError as e:
            self.textCtrl1.SetValue('Eingabefehler')

    def OnText(self, event):                      ## sinnvoll ??
        inhalt=self.textCtrl1.GetValue() # neu
        try:
            self.__modell.Waehle(int(self.textCtrl1.GetValue())-1)  # neu!
        except ValueError as e:
            pass
        
    ### Menu-Abschnitt
    def OnOeffnen(self, event):
        ##self.textCtrl1.SetValue('Oeffnen angeklickt')
        self.__modell.Lade('Daten/daten_1.dat')

    def OnSpeichern(self, event):
        ##self.textCtrl1.SetValue('Speichern angeklickt')
        self.__modell.Speichere('Daten/daten_1.dat')

    def OnStuhl(self, event):
        ##self.textCtrl1.SetValue('erzeuge Stuhl angeklickt')
        self.__modell.Neu('Stuhl', sichtbar=True)

    def OnTisch(self, event):
        ##self.textCtrl1.SetValue('erzeuge Tisch angeklickt')
        self.__modell.Neu('Tisch', sichtbar=True)

    def OnSchrank(self, event):
        ##self.textCtrl1.SetValue('erzeuge Schrank angeklickt')
        self.__modell.Neu('Schrank', sichtbar=True)


    ### Button-Abschnitt
    def OnWaehle(self, event):        
        ausgewaehlt=self.__modell.Waehle() # neu
        if ausgewaehlt==-1: ausgewaehlt='keines' # neu
        if type(ausgewaehlt)==int: ausgewaehlt+=1 # neu
        self.textCtrl1.SetValue(str(ausgewaehlt)) # neu
    
    def OnDrehe(self, event):
        self.__modell.Drehe(30)
    
    def OnBeenden(self, event):
        self.Close(True)

    def OnCloseWindow(self, event):
        self.Destroy()

    def EvtListBox(self, event):
        self.__modell.Neu(self.lb.GetString(self.lb.GetSelection()),
                          sichtbar=True)

### ---------------------------------------------------
class RaumplanerApp(wx.App):
    """Anwendung fuer Raumplaner"""
    def OnInit(self):
        self.fenster = Gui(None, 1000, "Raumplaner")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = RaumplanerApp(redirect=False)
    app.MainLoop()
